﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart.Styles;

namespace SendProject
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InitializeChart();
        }
        private Steema.TeeChart.Styles.Line line1;
        private Steema.TeeChart.Tools.CursorTool cursorTool1;
        private Steema.TeeChart.Tools.Annotation ann;
        private double xval;
        private void InitializeChart()
        {
            tChart1.Aspect.View3D = false;
           
            //Tools
            cursorTool1 = new Steema.TeeChart.Tools.CursorTool(tChart1.Chart);
            cursorTool1.Style = Steema.TeeChart.Tools.CursorToolStyles.Vertical;
            cursorTool1.Pen.Style = System.Drawing.Drawing2D.DashStyle.Dash;
            cursorTool1.FollowMouse = true;
            ann = new Steema.TeeChart.Tools.Annotation(tChart1.Chart);
            ann.Shape.Pen.Visible = false;
            ann.Shape.Shadow.Visible = false;
            ann.Shape.ShapeStyle = Steema.TeeChart.Drawing.TextShapeStyle.RoundRectangle;
           //Series
            line1 = new Line(tChart1.Chart);
            line1.Pointer.Visible = true;
            DateTime dt = DateTime.Now;
            Random rnd = new Random();

            for (int i = 0; i < 10; i++)
            {
                line1.Add(dt, rnd.Next(100));
                dt = dt.AddHours(1);
            }
            //Axes
            tChart1.Axes.Bottom.Labels.DateTimeFormat = "HH:mm:ss";
            //Events
            tChart1.AfterDraw +=new Steema.TeeChart.PaintChartEventHandler(tChart1_AfterDraw);
            cursorTool1.Change +=new Steema.TeeChart.Tools.CursorChangeEventHandler(cursorTool1_Change);
            tChart1.Draw();
        }
        private double InterpolateLineSeries(Steema.TeeChart.Styles.Custom series, int firstindex, int lastindex, double xvalue)
        {
            
            int index;
            for (index = firstindex; index <= lastindex; index++)
            {
                if (index == -1 || series.XValues.Value[index] > xvalue) break;
            }
            // safeguard
            if (index < 1) index = 1;
            else if (index >= series.Count) index = series.Count - 1;
            // y=(y2-y1)/(x2-x1)*(x-x1)+y1
            double dx = series.XValues[index] - series.XValues[index - 1];
            double dy = series.YValues[index] - series.YValues[index - 1];
            if (dx != 0.0) return dy * (xvalue - series.XValues[index - 1]) / dx + series.YValues[index - 1];
            else return 0.0;
        }

        private double InterpolateLineSeries(Steema.TeeChart.Styles.Custom series, double xvalue)
        {
            return InterpolateLineSeries(series, series.FirstVisibleIndex, series.LastVisibleIndex, xvalue);
        }
        private void cursorTool1_Change(object sender, Steema.TeeChart.Tools.CursorChangeEventArgs e)
        {
            xval = e.XValue;
            ann.Text = "";
            for (int i = 0; i < tChart1.Series.Count; i++)
                if (tChart1.Series[i] is Steema.TeeChart.Styles.Custom)
                {
                    ann.Text += DateTime.FromOADate(e.XValue).ToString("HH:mm:ss");
                }
        }
        private void tChart1_AfterDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {
            int xs = tChart1.Axes.Bottom.CalcXPosValue(xval);
            int ys;
            g.Brush.Visible = true;
            g.Brush.Solid = true;
            for (int i = 0; i < tChart1.Series.Count; i++)

                if (tChart1.Series[i] is Steema.TeeChart.Styles.Custom)
                {
                    ys = tChart1.Series[i].GetVertAxis.CalcYPosValue(InterpolateLineSeries(tChart1.Series[i] as Steema.TeeChart.Styles.Custom, xval));
                    //Draw elipse above cursor tool.
                    g.Brush.Color = tChart1.Series[i].Color;
                    g.Ellipse(new Rectangle(xs - 4, ys - 4, 8, 8));
                    //Draw annotation as label above cursor tool.
                    ann.Top = ys;
                    ann.Left = xs;
                }
        }
    }
}
